    SUBROUTINE ZERO3(ARRAY, LL)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE ZERO3
!>
!> SUBROUTINE: ZERO3 - ZERO OUT 3-D ARRAYS
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 96-03-28
!>
!> ABSTRACT:
!> SET THE VALUES OF THE ARTIFICIAL EXTERNAL (OUT-OF-BOUNDS) EDGES TO ZERO
!>
!> PROGRAM HISTORY LOG:
!> 96-03-28  BLACK      - ORIGINATOR
!> 97-06-??  MEYS       - MODIFIED FOR DISTRIBUTED MEMORY
!> 99-07-06  BLACK      - FULL ARRAY AND NOT JUST EDGES
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LL    -
!>
!> OUTPUT ARGUMENT LIST:
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> ARRAY - 
!>
!> OUTPUT FILES:
!> NONE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : INIT
!>              INITS
!>              TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LL)         , INTENT(INOUT)       ::&
    & ARRAY
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LL
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , L      
!
    DO L=1,LL
        DO J=JDIM1,JDIM2
            DO I=IDIM1,IDIM2
                ARRAY(I,J,L) = 0.
            END DO
        END DO
    END DO
!
    RETURN
!
    END SUBROUTINE ZERO3

    SUBROUTINE READ_RESTRT
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE READ_RESTRT
!>
!> SUBPROGRAM: READ_RESTRT - READ AND DISTRIBUTE RESTRT FILE
!> PROGRAMMER: BLACK
!> ORG: W/NP2
!> DATE: 98-10-22
!>
!> ABSTRACT:
!> READ_RESTRT READS IN QUANTITIES FROM THE NFC FILE OR THE RESTRT FILE AND DISTRIBUTES THEM TO THE 
!> OTHER NODES/PES
!>
!> PROGRAM HISTORY LOG:
!v 97-??-??  MEYS       - ORIGINATOR
!> 97-08-??  BLACK      - REWROTE FOR BENCHMARK
!> 98-??-??  TUCCILLO   - MODIFIED FOR SINGLE OR DOUBLE PRECISION
!> 98-10-23  BLACK      - MODIFIED FOR NEWEST RESTART FILE
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> NONE
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE 
!>
!> USE MODULES: ACMCLD
!>              ACMCLH 
!>              ACMPRE
!>              ACMRDL
!>              ACMRDS
!>              ACMSFC
!>              BOCO
!>              CLDWTR
!>              CNVCLD
!>              CONTIN
!>              CTLBLK
!>              DYNAM
!>              F77KINDS
!>              GLB_TABLE
!>              INDX
!>              LOOPS
!>              MAPOT
!>              MAPPINGS
!>              MASKS
!>              MPPCOM
!>              OUTFIL
!>              PARMETA
!>              PARMSOIL
!>              PARM_TBL
!>              PHYS
!>              PRFHLD
!>              PVRBLS
!>              SOIL
!>              TEMPCOM
!>              TOPO
!>              VRBLS
!>
!> DRIVER     : INIT
!>              INITS
!>
!> CALLS      : DSTRB
!>              IDSTRB
!>              MPI_BARRIER
!>              MPI_BCAST
!>--------------------------------------------------------------------------------------------------
    USE ACMCLD
    USE ACMCLH
    USE ACMPRE
    USE ACMRDL
    USE ACMRDS
    USE ACMSFC
    USE BOCO
    USE CLDWTR
    USE CNVCLD
    USE CONTIN
    USE CTLBLK
    USE DYNAM
    USE F77KINDS
    USE GLB_TABLE
    USE INDX
    USE LOOPS
    USE MAPOT
    USE MAPPINGS
    USE MASKS
    USE MPPCOM
    USE OUTFIL
    USE PARMETA
    USE PARMSOIL
    USE PARM_TBL
    USE PHYS
    USE PRFHLD 
    USE PVRBLS
    USE SOIL
    USE TEMPCOM
    USE TOPO
    USE VRBLS
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: D00    =    0.0
    REAL   (KIND=R4KIND), PARAMETER :: D50    =     .50
    REAL   (KIND=R4KIND), PARAMETER :: H1     =    1.0
    REAL   (KIND=R4KIND), PARAMETER :: G      =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: CM1    = 2937.4
    REAL   (KIND=R4KIND), PARAMETER :: CM2    =    4.9283
    REAL   (KIND=R4KIND), PARAMETER :: CM3    =   23.5518
    REAL   (KIND=R4KIND), PARAMETER :: EPS    =    0.622
    REAL   (KIND=R4KIND), PARAMETER :: Q2INI  =     .50
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2  =    2.E-2
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ   =    2.E-12 
    REAL   (KIND=R4KIND), PARAMETER :: EPSWET =    0.0
    REAL   (KIND=R4KIND), PARAMETER :: Z0LAND =     .10
    REAL   (KIND=R4KIND), PARAMETER :: Z0SEA  =     .001 
    REAL   (KIND=R4KIND), PARAMETER :: FCM    =     .00001 
    REAL   (KIND=R4KIND), PARAMETER :: DTR    =    0.1745329E-1
    REAL   (KIND=R4KIND), PARAMETER :: H360   =  360.0
    REAL   (KIND=R4KIND), PARAMETER :: H1905  =  190.5
    REAL   (KIND=R4KIND), PARAMETER :: H105   =  105.0
!
    INTEGER(KIND=I4KIND), PARAMETER :: IMJM = IM * JM - JM / 2
    INTEGER(KIND=I4KIND), PARAMETER :: JMP1 = JM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: IMT  =  2 * IM - 1
!------------------  
! DECLARE VARIABLES
!------------------ 
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & RUNB
!
    CHARACTER(32)                                                                               ::&
    & LABEL
!
    CHARACTER(40)                                                                               ::&
    & CONTRL  , FILALL  , FILMST  , FILTMP  , FILTKE  , FILUNV  , FILCLD  , FILRAD  , FILSFC
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PSLP
!
    REAL   (KIND=R4KIND), DIMENSION(IM, JM, NSOIL)                                              ::&
    & TEMPSOIL
!
    INTEGER(KIND=I4KIND), DIMENSION(3)                                                          ::&
    & IDATB   
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & LDUMMY   
!
    INCLUDE "mpif.h"
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), DIMENSION(MPI_STATUS_SIZE)                                            ::&
    & ISTAT
!
#ifdef DP_REAL
!
    LOGICAL(KIND=L8KIND)                                                                        ::&
    & RUNX    , FIRSTX
!
    INTEGER(KIND=I8KIND), DIMENSION(3)                                                          ::&
    & IDATX
!
    INTEGER(KIND=I8KIND)                                                                        ::&
    & IHRSTX  , NTSDX   , IOUTX   , NSHDEX
!
    INTEGER(KIND=I8KIND), DIMENSION(IM, JM)                                                     ::&
    & ITEMPX  , ITEMP2X
!
#endif
!
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & I       , J       , K       , N       , IER     , IRTN    , IYR     , IMNTH   , IDAY    ,   &
    & LBM2    , IHOUR 
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & TSTART  , PDOMG   , RESOMG  , DUMMY   , TEMP9   , TEMP10  , TEMP11 
!------------------------------------ 
! TSTART IS THE INITIAL TIME IN HOURS
!------------------------------------ 
    TSTART = NSTART * DT / 3600.
!----------------------------------------- 
! READ INITIAL CONDITIONS OR RESTART FILE.
! FIRST, THE .NOT. RESTART FILE CASE.
!----------------------------------------- 
    NFCST = 13
!Andre(RESTRT)    OPEN(UNIT=NFCST,FILE='INIT.file',STATUS='OLD',FORM='UNFORMATTED')
    OPEN(UNIT=NFCST,STATUS='OLD',FORM='UNFORMATTED')
    IF (.NOT. RESTRT) THEN
        IF (MYPE == 0) THEN
!
#ifdef DP_REAL
!   
            READ(NFCST) RUNX, IDATX, IHRSTX, NTSDX
            RUN   = RUNX
            IDAT  = IDATX
            IHRST = IHRSTX
            NTSD  = NTSDX
!
#else
!
            READ(NFCST) RUN, IDAT, IHRST, NTSD
!
#endif
!           
            IF (NTSD == 1 ) NTSD = 0
        ELSE
            READ(NFCST) DUMMY
        END IF
!    
        CALL MPI_BCAST  (RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BARRIER(                            MPI_COMM_COMP, IRTN)
!-------------- 
! DISTRIBUTE PD
!-------------- 
        IF (MYPE == 0) THEN
            READ(NFCST)TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, PD, 1, 1, 1)
!--------------- 
! DISTRIBUTE RES
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, RES, 1, 1, 1)
!---------------
! DISTRIBUTE FIS
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, FIS, 1, 1, 1)
!------------- 
! DISTRIBUTE U
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, U, 1, LM, K)
        END DO
!------------- 
! DISTRIBUTE V
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, V, 1, LM, K)
        END DO
!------------- 
! DISTRIBUTE T
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, T, 1, LM, K)
        END DO

!------------- 
! DISTRIBUTE Q
!------------- 
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
            CALL DSTRB(TEMP1, Q, 1, LM, K)
        END DO
!-------------- 
! DISTRIBUTE SI
!--------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, SI, 1, 1, 1)
!---------------
! DISTRIBUTE SNO
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, SNO, 1, 1, 1)
!---------------
! DISTRIBUTE SMC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, SMC, NSOIL, NSOIL, NSOIL)
!---------------
! DISTRIBUTE CMC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, CMC, 1, 1, 1)
!---------------
! DISTRIBUTE STC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST)TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, STC, NSOIL, NSOIL, NSOIL)
!----------------
! DISTRIBUTE SH2O
!----------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, SH2O, NSOIL, NSOIL, NSOIL)
!------------------
! DISTRIBUTE ALBEDO
!------------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, ALBEDO, 1, 1, 1)
!
        IYR   = IDAT(3) - 1900
        IMNTH = IDAT(1)
        IDAY  = IDAT(2)
!
        IF (MYPE == 0) WRITE(LIST,*) 'INIT: READ INITIAL CONDITION FILE'
!-------------------------------
! SECOND, THE RESTART FILE CASE.
!-------------------------------    
    ELSE
        IF (MYPE == 0) WRITE(LIST,*)'INIT:  READ RESTART FILE'
!
        IF (MYPE == 0) THEN
!
            READ(NFCST) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR
!
            IF (NTSD == 1) NTSD = 0
!
            READ(NFCST) PDOMG, RESOMG
        END IF
!    
        CALL MPI_BCAST(RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
!------------------ 
! DISTRIBUTE OMGALF
!------------------
        DO K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1
            END IF
!
            CALL DSTRB(TEMP1, OMGALF, 1, LM, K)
!
        END DO
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ  ',LABEL
!    
        IF (MYPE == 0) THEN
!
            READ(NFCST) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR, FIRST, IOUT, NSHDE
!
            IF (NTSD == 1) NTSD = 0
        END IF
!    
        FIRST = .TRUE. 
!    
        CALL MPI_BCAST(RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(FIRST  , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IOUT   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NSHDE  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3
        END IF
!    
        CALL DSTRB(TEMP1,PD ,1,1,1)
        CALL DSTRB(TEMP2,RES,1,1,1)
        CALL DSTRB(TEMP3,FIS,1,1,1)
!
        LBM2 = LB * LM * 2
!
        IF (MYPE == 0) THEN
            IF (NINT(TSTART) == 0) THEN
                READ(NFCST) PDB, TB, QB, UB, VB
            ELSE
                READ(NFCST) PDB, TB, QB, UB, VB, Q2B, CWMB
            END IF
        END IF
!    
        CALL MPI_BCAST(PDB(1,1)  , LB  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(PDB(1,2)  , LB  , MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(TB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(QB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(UB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(VB (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!    
        IF (NINT(TSTART) > 0) THEN
            CALL MPI_BCAST(Q2B (1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
            CALL MPI_BCAST(CWMB(1,1,1), LBM2, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        END IF
!----------------------
! PRIMARY 3-D VARIABLES
!----------------------
        DO 300 K=1,LM
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1 ! T (I,J,K)
                READ(NFCST) TEMP2 ! Q (I,J,K)
                READ(NFCST) TEMP3 ! U (I,J,K)
                READ(NFCST) TEMP4 ! V (I,J,K)
                READ(NFCST) TEMP5 ! Q2(I,J,K)
            END IF
!       
            CALL DSTRB(TEMP1, T , 1, LM, K)
            CALL DSTRB(TEMP2, Q , 1, LM, K)
            CALL DSTRB(TEMP3, U , 1, LM, K)
            CALL DSTRB(TEMP4, V , 1, LM, K)
            CALL DSTRB(TEMP5, Q2, 1, LM, K)
!----------------------------------------------------------------------------------------------------------        
! DUMMY READ OF THE TOTAL RADIATIVE TEMPERATURE TENDENCIES WHICH ARE NOT USED EXPLICITLY IN THE INTEGRATION
!----------------------------------------------------------------------------------------------------------          
            IF (MYPE == 0) THEN
                READ(NFCST)                                ! TTND(I,J,L)
!            
                READ(NFCST)((TEMP6(I,J), I=1,IM), J=1, JM) ! CWM  (I,J,K)
                READ(NFCST)((TEMP7(I,J), I=1,IM), J=1, JM) ! TRAIN(I,J,K)
                READ(NFCST)((TEMP8(I,J), I=1,IM), J=1, JM) ! TCUCN(I,J,K)
!            
            END IF
!        
            CALL DSTRB(TEMP6, CWM  , 1, LM, K)
            CALL DSTRB(TEMP7, TRAIN, 1, LM, K)
            CALL DSTRB(TEMP8, TCUCN, 1, LM, K)
!        
        300 END DO
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (3) '
!    
        IF (MYPE == 0) THEN
#ifdef DP_REAL
            READ(NFCST) RUNX, IDATX, IHRSTX, NTSDX, LABEL, TEMP1, TEMP2, TEMP3, TEMP4,            &
    &                   ((TEMP5(I,J),I=1,IM), J=1, JM), TEMP6
            RUN   = RUNX
            IDAT  = IDATX
            IHRST = IHRSTX
            NTSD  = NTSDX
#else
            READ(NFCST) RUN ,IDAT, IHRST, NTSD, LABEL, IHOUR, TEMP1, TEMP2, TEMP3, TEMP4,         &
    &                   ((TEMP5(I,J),I=1,IM), J=1, JM), TEMP6
#endif
            IF (NTSD == 1) NTSD=0
        END IF
!    
        CALL DSTRB(TEMP1, RSWIN , 1, 1, 1)
        CALL DSTRB(TEMP2, RSWOUT, 1, 1, 1)
        CALL DSTRB(TEMP3, TG    , 1, 1, 1)
        CALL DSTRB(TEMP4, Z0    , 1, 1, 1)
        CALL DSTRB(TEMP5, AKMS  , 1, 1, 1)
        CALL DSTRB(TEMP6, CZEN  , 1, 1, 1)
!    
        CALL MPI_BCAST(RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3, TEMP4, TEMP5, TEMP6, TEMP7
        END IF
!          
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (4) '
!	 
        CALL DSTRB(TEMP1, AKHS  , 1, 1, 1)
        CALL DSTRB(TEMP2, THS   , 1, 1, 1)
        CALL DSTRB(TEMP3, QS    , 1, 1, 1)
        CALL DSTRB(TEMP4, TWBS  , 1, 1, 1)
        CALL DSTRB(TEMP5, QWBS  , 1, 1, 1)
        CALL DSTRB(TEMP6, HBOT  , 1, 1, 1) ! USED TO BE CNVBOT
        CALL DSTRB(TEMP7, CFRACL, 1, 1, 1)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, ((TEMP3(I,J),I=1,IM), J=1, JM),                             &
    &                   ((TEMP4(I,J),I=1,IM), J=1, JM), TEMP5, TEMP6, TEMP7
        END IF
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (5) '
!    
        CALL DSTRB(TEMP1, THZ0  , 1, 1, 1)
        CALL DSTRB(TEMP2, QZ0   , 1, 1, 1)
        CALL DSTRB(TEMP3, UZ0   , 1, 1, 1)
        CALL DSTRB(TEMP4, VZ0   , 1, 1, 1)
        CALL DSTRB(TEMP5, USTAR , 1, 1, 1)
        CALL DSTRB(TEMP6, HTOP  , 1, 1, 1) ! USED TO BE CNVTOP
        CALL DSTRB(TEMP7, CFRACM, 1, 1, 1)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3, TEMP4, TEMP5, TEMP6, TEMP7
        END IF
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (6) '
!    
        CALL DSTRB(TEMP1, SNO   , 1, 1, 1)
        CALL DSTRB(TEMP2, SI    , 1, 1, 1)
        CALL DSTRB(TEMP3, CLDEFI, 1, 1, 1)
        CALL DSTRB(TEMP4, RF    , 1, 1, 1)
        CALL DSTRB(TEMP5, PSLP  , 1, 1, 1)
        CALL DSTRB(TEMP6, CUPPT , 1, 1, 1)
        CALL DSTRB(TEMP7, CFRACH, 1, 1, 1)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3, TEMP4, TEMP5, TEMP6
        END IF
!    
        CALL DSTRB(TEMP1, SOILTB, 1, 1, 1)
        CALL DSTRB(TEMP2, SFCEXC, 1, 1, 1)
        CALL DSTRB(TEMP3, SMSTAV, 1, 1, 1)
        CALL DSTRB(TEMP4, SMSTOT, 1, 1, 1)
        CALL DSTRB(TEMP5, GRNFLX, 1, 1, 1)
        CALL DSTRB(TEMP6, PCTSNO, 1, 1, 1)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, ((TEMP2(I,J),I=1,IM), J=1, JM), TEMP3, TEMP4
        END IF
!    
        CALL DSTRB(TEMP1, RLWIN , 1, 1, 1)
        CALL DSTRB(TEMP2, RADOT , 1, 1, 1)
        CALL DSTRB(TEMP3, CZMEAN, 1, 1, 1)
        CALL DSTRB(TEMP4, SIGT4 , 1, 1, 1)
!--------------------------------------------------------------------------------------------------
! READ OLD ARRAYS FROM ZHAO SCHEME BUT DO NOT DISTRIBUTE. 
! ARRAY SR IS STILL USED ("SNOW RATIO" OR FRACTION OF INSTANTANEOUS PRECIPITATION IN THE FORM OF 
! SNOW).
!--------------------------------------------------------------------------------------------------   
        IF (MYPE == 0) THEN
#ifdef DP_REAL
            READ(NFCST) TEMP1, UL, ITEMPX, TEMP3
            ITEMP = ITEMPX
#else
            READ(NFCST) TEMP1, UL, ITEMP, TEMP3
#endif
        END IF
!    
        CALL DSTRB    (TEMP1, U00, 1, 1, 1) ! U00 ARRAY NOT USED IN NEW G/S SCHEME
        CALL IDSTRB   (ITEMP, LC          ) ! LC ARRAY NOT USED IN NEW G/S SCHEME
        CALL DSTRB    (TEMP3, SR , 1, 1 ,1) ! SR ARRAY *IS* STILL USED
        CALL MPI_BCAST(UL(1), 2*LM, MPI_REAL, 0, MPI_COMM_COMP, IRTN) ! UL ARRAY NOT USED
!
        IF (MYPE == 0) THEN
#ifdef DP_REAL
            READ(NFCST) RUNX, IDATX, IHRSTX, NTSDX, LABEL, TEMP1, TEMP2, TEMP3, TEMP4
            RUN   = RUNX
            IDAT  = IDATX
            IHRST = IHRSTX
            NTSD  = NTSDX
#else
            READ(NFCST) RUN, IDAT, IHRST, NTSD, LABEL, IHOUR, TEMP1, TEMP2, TEMP3, TEMP4
#endif
            IF (NTSD == 1) NTSD=0
        END IF
!    
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (7) '
!
        CALL DSTRB(TEMP1, PREC  , 1, 1, 1)
        CALL DSTRB(TEMP2, ACPREC, 1, 1, 1)
        CALL DSTRB(TEMP3, ACCLIQ, 1, 1, 1)
        CALL DSTRB(TEMP4, CUPREC, 1, 1, 1)
!
        CALL MPI_BCAST(RUN    , 1, MPI_LOGICAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IDAT(1), 3, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(IHRST  , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST(NTSD   , 1, MPI_INTEGER, 0, MPI_COMM_COMP, IRTN)
!
        IF (MYPE == 0) THEN
#ifdef DP_REAL
            READ(NFCST) TEMP1, ITEMPX, TEMP3, ITEMP2X
            ITEMP  = ITEMPX
            ITEMP2 = ITEMP2X
#else
            READ(NFCST) TEMP1, ITEMP, TEMP3, ITEMP2
#endif
        END IF
!    
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (8) '
!
        CALL DSTRB (TEMP1 , ACFRCV, 1, 1, 1)
        CALL IDSTRB(ITEMP , NCFRCV         )
        CALL DSTRB (TEMP3 , ACFRST, 1, 1, 1)
        CALL IDSTRB(ITEMP2, NCFRST         )
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3, TEMP4
        END IF
!    
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (9) '
!
        CALL DSTRB(TEMP1, ACSNOW, 1, 1, 1)
        CALL DSTRB(TEMP2, ACSNOM, 1, 1, 1)
        CALL DSTRB(TEMP3, SSROFF, 1, 1, 1)
        CALL DSTRB(TEMP4, BGROFF, 1, 1, 1)
!
        IF (MYPE == 0) THEN
            READ(NFCST)TEMP1, TEMP2, TEMP3, TEMP4, TEMP5, TEMP6, TEMP7
        END IF
!    
        CALL DSTRB(TEMP1, SFCSHX, 1, 1, 1)
        CALL DSTRB(TEMP2, SFCLHX, 1, 1, 1)
        CALL DSTRB(TEMP3, SUBSHX, 1, 1, 1)
        CALL DSTRB(TEMP4, SNOPCX, 1, 1, 1)
        CALL DSTRB(TEMP5, SFCUVX, 1, 1, 1)
        CALL DSTRB(TEMP6, SFCEVP, 1, 1, 1)
        CALL DSTRB(TEMP7, POTEVP, 1, 1, 1)
!
        IF (MYPE == 0) THEN
            READ(NFCST)TEMP1, TEMP2, TEMP3, TEMP4, TEMP5, TEMP6
        END IF
!    
        CALL DSTRB(TEMP1, ASWIN , 1, 1, 1)
        CALL DSTRB(TEMP2, ASWOUT, 1, 1, 1)
        CALL DSTRB(TEMP3, ASWTOA, 1, 1, 1)
        CALL DSTRB(TEMP4, ALWIN , 1, 1, 1)
        CALL DSTRB(TEMP5, ALWOUT, 1, 1, 1)
        CALL DSTRB(TEMP6, ALWTOA, 1, 1, 1)
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (10) '
!
        IF (MYPE == 0) THEN
            READ(NFCST) ARDSW, ARDLW, ASRFC, AVRAIN, AVCNVC
        END IF
!    
        CALL MPI_BCAST  (ARDSW , 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (ARDLW , 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (ASRFC , 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (AVRAIN, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BCAST  (AVCNVC, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
        CALL MPI_BARRIER(                        MPI_COMM_COMP, IRTN)
!
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1, TEMP2, TEMP3, TEMP4, TEMP5, TEMP6, TEMP7,                          &
!--------- 
! SM v100M
!--------- 
    &                   TEMP12, TEMP13, TEMP14, TEMP15
        END IF
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (11) '
!    
        CALL DSTRB(TEMP1, TH10  , 1, 1, 1)
        CALL DSTRB(TEMP2, Q10   , 1, 1, 1)
        CALL DSTRB(TEMP3, U10   , 1, 1, 1)
        CALL DSTRB(TEMP4, V10   , 1, 1, 1)
        CALL DSTRB(TEMP5, TSHLTR, 1, 1, 1)
        CALL DSTRB(TEMP6, QSHLTR, 1, 1, 1)
        CALL DSTRB(TEMP7, PSHLTR, 1, 1, 1)
!--------- 
! SM v100M
!---------
        CALL DSTRB(TEMP12, TH100, 1, 1, 1)
        CALL DSTRB(TEMP13, Q100 , 1, 1, 1)
        CALL DSTRB(TEMP14, U100 , 1, 1, 1)
        CALL DSTRB(TEMP15, V100 , 1, 1, 1)
!--------- 
! SM v100M
!---------
!
!---------------         
! DISTRIBUTE SMC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, SMC, NSOIL, NSOIL, NSOIL)
!---------------
! DISTRIBUTE CMC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
!    
        CALL DSTRB(TEMP1, CMC, 1, 1, 1)
!---------------
! DISTRIBUTE STC
!---------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, STC, NSOIL, NSOIL, NSOIL)
!----------------
! DISTRIBUTE SH2O
!----------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMPSOIL
        END IF
!    
        CALL DSTRB(TEMPSOIL, SH2O, NSOIL, NSOIL, NSOIL)
!------------------
! DISTRIBUTE ALBEDO
!------------------
        IF (MYPE == 0) THEN
            READ(NFCST) TEMP1
        END IF
! 
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (12) '
!   
        CALL DSTRB(TEMP1, ALBEDO, 1, 1, 1)
!--------------------------------------------------------------------------------
! IF FORECAST IS NOT BEGINNING AT TIME 0 THEN WE MUST READ ADDITIONAL INFORMATION
!--------------------------------------------------------------------------------
        IF (NINT(TSTART) /= 0) THEN
!        
            IF (MYPE == 0) THEN
                READ(NFCST) TEMP1, TEMP2, TEMP3, ACUTIM, ARATIM, APHTIM,                          & 
    &                        NHEAT, NPHS, NCNVC, NPREC, NRDSW, NRDLW,                             &
    &                        NSRFC, TPH0D, TLM0D, LDUMMY
            END IF
!
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (13) '
!
            CALL DSTRB(TEMP1, POTFLX, 1, 1, 1)
            CALL DSTRB(TEMP2, TLMIN , 1, 1, 1)
            CALL DSTRB(TEMP3, TLMAX , 1, 1, 1)
!
            CALL MPI_BCAST(ACUTIM, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
            CALL MPI_BCAST(ARATIM, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
            CALL MPI_BCAST(APHTIM, 1, MPI_REAL, 0, MPI_COMM_COMP, IRTN)
!        
            DO K=1,LM
                IF (MYPE == 0) THEN
                    READ(NFCST)TEMP1 ! RSWTT
                    READ(NFCST)TEMP2 ! RLWTT
                END IF
!            
                CALL DSTRB(TEMP1, RSWTT, 1, LM, K)
                CALL DSTRB(TEMP2, RLWTT, 1, LM, K)
            END DO
!        
            IF (MYPE == 0) THEN
                READ(NFCST)TEMP2 ! CNVBOT (USED TO BE HBOT)
                READ(NFCST)TEMP3 ! CNVTOP (USED TO BE HTOP)
                READ(NFCST)TEMP4 ! RSWTOA
                READ(NFCST)TEMP5 ! RLWTOA
            END IF
! 
        IF (MYPE == 0) WRITE(LIST,*)'  READ RESTRT (14) '
!       
            CALL DSTRB(TEMP2, CNVBOT, 1, 1, 1)
            CALL DSTRB(TEMP3, CNVTOP, 1, 1, 1)
            CALL DSTRB(TEMP4, RSWTOA, 1, 1, 1)
            CALL DSTRB(TEMP5, RLWTOA, 1, 1, 1)
        END IF
!-----------------------------------------------------------------------
! CALL RADIATION TO OBTAIN THE SHORT AND LONGWAVE TEMPERATURE TENDENCIES
!-----------------------------------------------------------------------

    END IF
!--------------------------------------------------- 
! DONE READING INITIAL CONDITIONS OR A RESTART FILE.
!---------------------------------------------------
!
!------------------------------ 
! END OF SUBROUTINE READ_RESTRT
!------------------------------ 
    IF (MYPE == 0) THEN
        WRITE(LIST,*) 'INIT:  EXIT READ_RESTRT'
        WRITE(LIST,*) ' '
    END IF
!
    RETURN
!
    END SUBROUTINE READ_RESTRT

    MODULE TOPO
!>--------------------------------------------------------------------------------------------------
!> MODULE TOPO
!>
!> ABSTRACT:
!> IT WAS CREATED FROM MPP.h
!>
!> USE MODULES: PARMETA
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLO89
!>              CLTEND
!>              COLLECT
!>              CONRAD
!>              CUCNVC
!>              DDAMP
!>              DIFCOF
!>              DIGFLT
!>              DIST
!>              DIVHOA
!>              DIVHOAST 
!>              DSTRB
!>              E1E290
!>              E290
!>              E2SPEC
!>              E3V88
!>              EBU
!>              EPS
!>              FILT25
!>              FST88
!>              GOSSIP
!>              GSCOND
!>              GSMCOLUMN
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              IDSTRB
!>              INIT
!>              INITS
!>              LOC2GLB
!>              LWR88
!>              MIXLEN
!>              MODULE_EXCHM
!>              MPI_FIRST
!>              MPPINIT
!>              NEWFLT
!>              OZON2D
!>              PDNEW
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              QUILT
!>              RADFS
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SFCDIF
!>              SFCDIF_BHS
!>              SLP
!>              SLPSIG
!>              SLPSIGSPLINE
!>              SPA88
!>              SURFCE
!>              SWR93
!>              TABLE
!>              TTBLEX
!>              TURBL
!>              TWR
!>              UPDATE
!>              VADZ
!>              VDIFH
!>              VDIFV
!>              VTADV
!>              VTADVF
!>              VWR
!>              ZENITH
!>              ZERO2
!>              ZERO3
!>              ZERO3_T  
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : IM, JM, LM
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(0:IM+1, 0:JM+1)                                             ::&
    & TEMP2X  ,                                                                                   &
    & TTVG 
!
    REAL   (KIND=R4KIND), DIMENSION(0:IM+1, 0:JM+1, LM)                                         ::&
    & HTMG
!
    END MODULE TOPO

    MODULE VRBLS
!>-------------------------------------------------------------------------------------------------- 
!> MODULE VRBLS
!>
!> USE MODULES: PARMETA
!>              RDPARM
!>
!> DRIVER     : BOCOH
!>              BOCOHF
!>              BOCOV
!>              CHKOUT
!>              CLTEND
!>              CUCNVC
!>              DDAMP
!>              DIGFLT
!>              DIVHOA
!>              DIVHOAST
!>              EBU
!>              EPS
!>              EXIT
!>              GOSSIP
!>              GSCOND
!>              GSMDRIVE
!>              HADZ
!>              HDIFF
!>              HDIFFS
!>              HZADV
!>              HZADVS
!>              HZADV2
!>              HZADV_LM1
!>              INIT
!>              INITS
!>              NEWFLT
!>              PDNEW
!>              PDTE
!>              PDTEDT
!>              PGCOR
!>              PRECPD
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              RES_RESTRT2
!>              SLADVT
!>              SURFCE
!>              TURBL
!v              TWR
!>              VADZ
!>              VTADV
!>              VTADVF
!>              VWR
!>              WRTRST
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA , ONLY : LM, IDIM1, IDIM2, JDIM1, JDIM2
!
    IMPLICIT NONE
!
    SAVE
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & PD      , FIS     , RES 
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & T       , U       , V       , Q
!
    END MODULE VRBLS

    SUBROUTINE MIXLEN(LMHK, LPBL, HPBL, U, V, T, Q, Q2, APE, Z, GM, GH, EL)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE MIXLEN
!>
!> SUBPROGRAM: MIXLEN - ?????
!> PROGRAMMER: ?????
!> ORG: ?????
!> DATE: ??-??-??
!>
!> ABSTRACT:
!> LEVEL 2.5 MIXING LENGTH 
!>
!> JULY 1997: MODIFIED TO RESTORE AVERAGING OF LAYER VALUES OF L, ELL, A LA MESINGER 1993, RES. ACT.
!>            ATMOS. OCEAN. MOD., NO. 18, 4.36 - 4.38;
!>
!> A PROBLEM REMOVED WHICH MAY HAVE LED TO THE ÒABOVE PBLÓ SCHEME FOR PRELIMINARY EL TO BE USED 
!> INADVERTENTLY AT TIMES AND PLACES WHERE THE PBL SCHEME WAS SUPPOSED TO HAVE BEEN USED.
!>
!> PROGRAM HISTORY LOG:
!> ??-??-??  JANJIC     - ORIGINATOR
!> 18-01-15  LUCCI      - MODERNIZATION OF THE CODE, INCLUDING:
!>                        * F77 TO F90/F95
!>                        * INDENTATION & UNIFORMIZATION CODE
!>                        * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                        * DOCUMENTATION WITH DOXYGEN
!>                        * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> LMVK  - MASS POINT MODEL SURFACE (LOWEST MODEL HEIGHT)
!> U     - (TRANSPOSED)
!> V     - (TRANSPOSED)
!> T     - (TRANSPOSED)
!> Q     - (TRANSPOSED)
!> Q2    - TURBULENT KINETIC ENERGY (TRANSPOSED)
!> APE   - EXNER FUNCTION
!>
!> OUTPUT ARGUMENT LIST:
!> HPBL  - HEIGHT OF THE PBL
!> GM    - WIND SHEAR
!> GH    - VERTICAL GRADIENT OS POTENTIAL TEMPERATURE
!> EL    -
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> LPBL  - THE EL VALUE OF L OF THE INTERFACE
!>
!> USE MODULES: F77KINDS
!>              GLB_TABLE
!>              MAPPINGS
!>              MPPCOM
!>              PARMETA
!>              TEMPCOM
!>              TOPO
!>
!> DRIVER     : TURBL
!>
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE GLB_TABLE
    USE MAPPINGS
    USE MPPCOM
    USE PARMETA
    USE TEMPCOM
    USE TOPO
!
    IMPLICIT NONE
!
#include "sp.h"
!
    INTEGER(KIND=I4KIND), PARAMETER :: LP1    = LM + 1
    INTEGER(KIND=I4KIND), PARAMETER :: LM1    = LM - 1
!
    REAL   (KIND=R4KIND), PARAMETER :: EPSQ2  =    0.2
    REAL   (KIND=R4KIND), PARAMETER :: EPSL   =    0.32
    REAL   (KIND=R4KIND), PARAMETER :: EPSRU  =    1.E-12
    REAL   (KIND=R4KIND), PARAMETER :: EPSRS  =    1.E-12
    REAL   (KIND=R4KIND), PARAMETER :: FH     =    1.01
    REAL   (KIND=R4KIND), PARAMETER :: ALPH   =     .20 
    REAL   (KIND=R4KIND), PARAMETER :: VKRM   =     .40 
    REAL   (KIND=R4KIND), PARAMETER :: ELFC   =    0.23   
    REAL   (KIND=R4KIND), PARAMETER :: EL0MAX = 1000.
    REAL   (KIND=R4KIND), PARAMETER :: G      =    9.8
    REAL   (KIND=R4KIND), PARAMETER :: BETA   =    1.    / 270. 
    REAL   (KIND=R4KIND), PARAMETER :: BTG    = BETA     * G
    REAL   (KIND=R4KIND), PARAMETER :: PRT    =    1.0
    REAL   (KIND=R4KIND), PARAMETER :: GAM1   =    0.2222222222222222222
    REAL   (KIND=R4KIND), PARAMETER :: A1     =    0.659888514560862645 
    REAL   (KIND=R4KIND), PARAMETER :: A2     =    0.6574209922667784586  
    REAL   (KIND=R4KIND), PARAMETER :: B1     =   11.87799326209552761   
    REAL   (KIND=R4KIND), PARAMETER :: B2     =    7.226971804046074028
    REAL   (KIND=R4KIND), PARAMETER :: C1     =    0.000830955950095854396
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                  , INTENT(IN)          ::&
    & LMHK  
!
    INTEGER(KIND=I4KIND)                                                  , INTENT(INOUT)       ::& 
    & LPBL 
!
    REAL   (KIND=R4KIND)                                                  , INTENT(INOUT)         ::& 
    & HPBL 
!---------------------------------------------------------- 
! N     &(G=9.8,BETA=1./270.,BTG=BETA*G
! N     &,PRT=1.0,GAM1=0.2222222222222222222
! N     &,A1=0.3310949523016403346,A2=0.8273378704055731278
! N     &,B1=5.959709141429526024,B2=3.626088092074591135
! N     &,C1=-0.3330651924968952113)
!---------------------------------------------------------- 
! Y     &(G=9.8,BETA=1./270.,BTG=BETA*G
! Y     &,PRT=0.8,GAM1=0.2222222222222222222
! Y     &,A1=0.9222222350809054114,A2=0.7350190142719400952
! Y     &,B1=16.60000023145629741,B2=10.10000014082581951
! Y     &,C1=0.0805318118080613468)
!---------------------------------------------------------- 
!
!---------------------------------------------  
! COEFFICIENTS OF THE TERMS IN THE DENOMINATOR
!---------------------------------------------  
    REAL   (KIND=R4KIND), PARAMETER                                                             ::&
    &          ADNM =18.*A1*A1*A2*(B2-3.*A2)*BTG        ,                                         &
    &          ADNH = 9.*A1*A2*A2*(12.*A1+3.*B2)*BTG*BTG,                                         &
    &          BDNM = 6.*A1*A1                          ,                                         &
    &          BDNH = 3.*A2*(7.*A1+B2)*BTG              ,                                         &
!---------------------------------------------------  
! FREE TERM IN THE EQUILIBRIUM EQUATION FOR (L/Q)**2 
!--------------------------------------------------- 
    &          AEQM = 3.*A1*A2*B1*(3.*A2+3.*B2*C1+18.*A1*C1-B2)*BTG+18.*A1*A1*A2*(B2-3.*A2)*BTG,  &
    &          AEQH = 9.*A1*A2*A2*B1*BTG*BTG+9.*A1*A2*A2*(12.*A1+3.*B2)*BTG*BTG                ,  &
!--------------------------  
! FORBIDDEN TURBULENCE AREA 
!--------------------------
    &          REQU = -AEQH/AEQM*1.02,                                                            &
    &         EPSGH = 1.E-9          ,                                                            &
    &         EPSGM = REQU*EPSGH     ,                                                            &
!------------------------------------------------------
! NEAR ISOTROPY FOR SHEAR TURBULENCE, WW/Q2 LOWER LIMIT 
!------------------------------------------------------
    &        UBRYL = (18.*REQU*A1*A1*A2*B2*C1*BTG+9.*A1*A2*A2*B2*BTG*BTG)/(REQU*ADNM+ADNH),       &
    &         UBRY = (1.+EPSRS)*UBRYL                                                     ,       &
    &        UBRY3 = 3.*UBRY                                                              ,       &
    &         AUBM = 54.*A1*A1*A2*B2*C1*BTG -ADNM*UBRY3                                   ,       &
    &         AUBH = 27.*A1*A2*A2*B2*BTG*BTG-ADNH*UBRY3                                   ,       &
    &         BUBM = 18.*A1*A1*C1           -BDNM*UBRY3                                   ,       &
    &         BUBH = (9.*A1*A2+3.*A2*B2)*BTG-BDNH*UBRY3                                   ,       &
    &         CUBR = 1.-UBRY3                                                             ,       &
    &        RCUBR = 1./CUBR
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                   , INTENT(IN)          ::&    
    & U       , V       , T       , Q       , Q2      , APE 
!
    REAL   (KIND=R4KIND), DIMENSION(LM)                                                         ::& 
    & Q1      , ELL     , THV
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                  , INTENT(INOUT)       ::& 
    & GM      , GH      , EL      
!
    REAL   (KIND=R4KIND), DIMENSION(LM1)                                                        ::& 
    ELM
!
    REAL   (KIND=R4KIND), DIMENSION(LP1)                                  , INTENT(IN)          ::& 
    & Z
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & LMHM    , LMHP    , L       , IVI     , LPBLP
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & SZQ     , SQ      , QDZL    , RDZ     , GML     , GHL     , EL0     , AUBR    , BUBR    ,   &
    & QOL2ST  , ELOQ2X  , ADEN    , BDEN    , QOL2UN  , VKRMZ    
!
    LMHM = LMHK - 1
    LMHP = LMHK + 1
!--------------------------- 
! FIND THE HEIGHT OF THE PBL
!---------------------------
!    LPBL = LMHK
!
!    DO 100 IVI=1,LMHK
!        L = LMHK - IVI
!        IF (Q2(L) <= EPSQ2 * FH) THEN
!            LPBL = L
!            GOTO 110
!        END IF
!100 END DO
!
!    LPBL = 1

    LPBL = LMHK-1
!
!    DO 100 L=LMHK/2, LMHK-1, 1 !Chou change the search from half atm to bottom
    DO 100 L= LMHK-1, LM/2, -1 !Chou change the search from bottom to half atm 
!
!    IF (Q2(L) >= EPSQ2 FH) THEN
    IF (Q2(L) <= EPSQ2 * FH) THEN 
        LPBL = L
        GOTO 110
    END IF
!    
100 END DO

!---------------------- 
! THE HEIGHT OF THE PBL 
!----------------------     
110 HPBL = Z(LPBL) - Z(LMHP)
!
    DO 120 L=1,LMHK
        Q1(L) = 0.
        THV(L) = (0.608 * Q(L) + 1.) * T(L) * APE(L)
120 END DO
!
    DO 130 L=LPBL,LMHK
        Q1(L) = SQRT(Q2(L))
130 END DO
!
    SZQ = 0.
    SQ  = 0.
!
    DO 140 L=1,LMHM
        QDZL = (Q1(L) + Q1(L+1)) * (Z(L+1) - Z(L+2))
!
        SZQ  = (Z(L+1) + Z(L+2) - Z(LMHP) - Z(LMHP)) * QDZL + SZQ
!
        SQ = QDZL + SQ
!
        RDZ = 2. / (Z(L) - Z(L+2))
!
        GML = ((U(L) - U(L+1)) ** 2 + (V(L) - V(L+1)) ** 2) * RDZ * RDZ
!
        GM(L) = AMAX1(GML,EPSGM)
!
        GHL = (THV(L) - THV(L+1)) * RDZ
!
        IF (ABS(GHL) <= EPSGH) GHL = EPSGH
!
        GH(L) = GHL
140 END DO
!------------------------------------------------- 
! COMPUTATION OF ASYMPTOTIC L IN BLACKADAR FORMULA 
!------------------------------------------------- 
    EL0 = AMIN1(ALPH * SZQ * 0.5 / SQ, EL0MAX)
!
    DO 150 L=1,LMHM
        GML = GM(L)
        GHL = GH(L)
!
        IF (GHL >= EPSGH )THEN
            IF (GML/GHL <= REQU) THEN
                ELM(L) = EPSL
            ELSE
                AUBR = (AUBM * GML + AUBH * GHL) * GHL
                BUBR =  BUBM * GML + BUBH * GHL
!
                QOL2ST = (-0.5 * BUBR + SQRT(BUBR * BUBR * 0.25 - AUBR * CUBR)) * RCUBR
                QOL2ST = AMAX1(QOL2ST, 1.E-8)
!
                ELOQ2X = 1. / QOL2ST
                ELM(L)  = AMAX1(SQRT(ELOQ2X * Q2(L)), EPSL)
            END IF
        ELSE
            ADEN = (ADNM * GML + ADNH * GHL) * GHL
            BDEN =  BDNM * GML + BDNH * GHL
!
            QOL2UN = -0.5 * BDEN + SQRT(BDEN * BDEN * 0.25 - ADEN)
            ELOQ2X = 1. / ((1. + EPSRU) * QOL2UN)
            ELM(L) = AMAX1(SQRT(ELOQ2X * Q2(L)), EPSL)
        END IF
150 END DO
!-----------------------------------------------------------------------
! LPBLM=LPBL-1
! DO 160 L=1,LPBLM
!    EL(L)=AMIN1((Z(L)-Z(L+2))*ELFC,ELM(L))
! 60 CONTINUE
! DO 165 L=LPBL,LMHM
!    VKRMZ=(Z(L+1)-Z(LMHP))*VKRM
! 65 EL(L)=AMIN1(VKRMZ/(VKRMZ/EL0+1.),ELM(L))
!-----------------------------------------------------------------------
!
!--------------------------------------------------------------------------------------------------
!     NOTE: LPBL IS THE EL VALUE OF L OF THE INTERFACE STARTING WITH THE LOWEST INTERFACE AND GOING 
! UP FOR THE FIRST TIME HAVING Q2 .LE. A SPECIFIED VALUE
!--------------------------------------------------------------------------------------------------  
    DO 160 L=1,LPBL
        ELL(L) = (Z(L) - Z(L+1)) * ELFC
160 END DO
!
    IF (LPBL < LMHK) THEN
        LPBLP = LPBL + 1
        DO 165 L=LPBLP,LMHK
            VKRMZ  = (0.5 * (Z(L) + Z(L+1)) - Z(LMHP)) * VKRM
            ELL(L) = VKRMZ / (VKRMZ / EL0 + 1.)
    165 END DO
    END IF
!
    DO 260 L=1,LMHM
        EL(L) = AMIN1(0.5 * (ELL(L) + ELL(L+1)), ELM(L))
260 END DO
!
    RETURN
!
    END SUBROUTINE MIXLEN

    SUBROUTINE SOLARD(R1)
!>--------------------------------------------------------------------------------------------------
!> SUBROUTINE SOLARD
!>
!> SUBPROGRAM: SOLARD - COMPUTE THE SOLAR-EARTH DISTANCE
!> PROGRAMMER: Q.ZHAO
!> ORG: W/NMC2
!> DATE: 96-07-23
!>
!> ABSTRACT:
!> SOLARD CALCULATES THE SOLAR-EARTH DISTANCE ON EACH DAY FOR USE IN SHORT-WAVE RADIATION.
!>
!> PROGRAM HISTORY LOG:
!> 96-07-23  Q.ZHAO      - ORIGINATOR
!> 98-10-09  Q.ZHAO      - CHANGED TO USE IW3JDN IN W3LIB TO CALCULATE JD.
!> 18-01-15  LUCCI       - MODERNIZATION OF THE CODE, INCLUDING:
!>                         * F77 TO F90/F95
!>                         * INDENTATION & UNIFORMIZATION CODE
!>                         * REPLACEMENT OF COMMONS BLOCK FOR MODULES
!>                         * DOCUMENTATION WITH DOXYGEN
!>                         * OPENMP FUNCTIONALITY
!>
!> INPUT ARGUMENT LIST:
!> NONE
!>
!> OUTPUT ARGUMENT LIST:
!> R1 - THE NON-DIMENSIONAL DISTANCE BETWEEN SUN AND THE EARTH (LESS THAN 1.0 IN SUMMER AND LARGER
!>      THAN 1.0 IN WINTER).
!>
!> INPUT/OUTPUT ARGUMENT LIST:
!> NONE
!>
!> USE MODULES: CTLBLK
!>              F77KINDS
!>
!> DRIVER     : INIT
!>              INITS
!> 
!> CALLS      : -----
!>--------------------------------------------------------------------------------------------------
    USE CTLBLK
    USE F77KINDS
    USE UPDATE_FLDS, ONLY: GETDATE
!
    IMPLICIT NONE
!
    REAL   (KIND=R4KIND), PARAMETER :: PI  = 3.1415926
    REAL   (KIND=R4KIND), PARAMETER :: PI2 = 2. * PI
!
    LOGICAL(KIND=L4KIND)                                                                        ::&
    & LEAP
!
    INTEGER(KIND=I4KIND), DIMENSION(12)                                                         ::&
    & NDM
!------------------------
! IMPLICIT NONE VARIABLES
!------------------------
    INTEGER(KIND=I4KIND)                                                                        ::&
    & JYR19   , JMN     , JDOR1   , JDOR2   , JYR     , JMNTH   , JDAY    , JHR     , JD      ,   &
    & IW3JDN  , ITER    , IYR     , IMO     , IDY     , CYR     , CMO     , CDY     , UTC     ,   &
    & CUTC
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & CCR     , TPP     , DAYINC  , DAT     , T       , YEAR    , EC      , DATE    , FJD     ,   &
    & EM      , E       , EP      , CR      
!
    REAL   (KIND=R4KIND)                                                  , INTENT(OUT)         ::&
    & R1
!
    DATA JYR19/1900/, JMN/0/, CCR/1.3E-6/
    DATA NDM/0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334/
!------------------------------------------------------------
! TPP = DAYS BETWEEN EPOCH AND PERIHELION PASSAGE OF 1900
! JDOR1 = JD OF DECEMBER 30, 1899 AT 12 HOURS UT
! JDOR2 = JD OF EPOCH WHICH IS JANUARY 0, 1990 AT 12 HOURS UT
!------------------------------------------------------------
    DATA TPP/1.55/, JDOR1/2415019/, JDOR2/2415020/
!--------------------------------------------------------------------------------------------------
! COMPUTES JULIAN DAY AND FRACTION FROM YEAR, MONTH, DAY AND TIME UT ACCURATE ONLY BETWEEN MARCH 1,
! 1900 AND FEBRUARY 28, 2100 BASED ON JULIAN CALENDAR CORRECTED TO CORRESPOND TO GREGORIAN CALENDAR
! DURING THIS PERIOD
!--------------------------------------------------------------------------------------------------
!
!----
! GSM
!----
    IYR = IDAT(3)
    IMO = IDAT(1)
    IDY = IDAT(2)
      
    UTC = (NTSD * DT) / 3600
!
    CALL GETDATE(IYR, IMO, IDY, UTC, CYR, CMO, CDY, CUTC)
!
!    WRITE(*,*) 'DATA INICIAL:', IYR, IMO, IDY, UTC, NTSD * DT / 3600
!    WRITE(*,*) 'DATA ATUAL:'  , CYR, CMO, CDY, CUTC
!
    JYR   = CYR
    JMNTH = CMO
    JDAY  = CDY
    JHR   = CUTC
!----
! GSM
!----
!    JYR   = IDAT(3)
!    JMNTH = IDAT(1)
!    JDAY  = IDAT(2)
!    JHR   = IHRST
!
    JD = IW3JDN(JYR, JMNTH, JDAY)
!
    IF (JHR >= 12) THEN
        JD  = JD-1
 7      FJD = .5E0 + .041666667E0 * FLOAT(JHR   ) + .00069444444E0 * FLOAT(JMN)
    ELSE
        FJD =        .041666667E0 * FLOAT(JHR-12) + .00069444444E0 * FLOAT(JMN)
    END IF
!
    DAYINC = JHR / 24.0
     JD    = JD + FJD + DAYINC
    FJD    = JD + FJD + DAYINC - JD
!----------------------------------- 
! CALCULATE THE SOLAR-EARTH DISTANCE
!----------------------------------- 
    DAT = FLOAT(JD - JDOR2) - TPP + FJD
!---------------------------------------------- 
! COMPUTES TIME IN JULIAN CENTURIES AFTER EPOCH
!---------------------------------------------- 
    T = FLOAT(JD - JDOR2) / 36525.E0
!-------------------------------------------------------------------
! COMPUTES LENGTH OF ANOMALISTIC AND TROPICAL YEARS (MINUS 365 DAYS)
!-------------------------------------------------------------------
    YEAR = .25964134E0 + .304E-5 * T
!------------------------------------ 
! COMPUTES ORBIT ECCENTRICITY  FROM T
!------------------------------------ 
    EC   = .01675104E0 - (.418E-4 + .126E-6 * T) * T
    YEAR = YEAR + 365.E0
!------------------------------------------ 
! DATE = DAYS SINCE LAST PERIHELION PASSAGE
!------------------------------------------ 
    DATE = MOD(DAT, YEAR)
!---------------------------------------- 
! SOLVE ORBIT EQUATIONS BY NEWTONS METHOD
!---------------------------------------- 
    EM = PI2 * DATE / YEAR
    E = 1.E0
    ITER = 0
 31 EP = E - (E - EC * SIN(E) - EM) / (1.E0 - EC*COS(E))
    CR = ABS(E - EP)
    E = EP
    ITER = ITER + 1
!
    IF (ITER >  10)  GOTO 931
    IF (CR   > CCR)  GOTO  31
!
 931 CONTINUE
!
    R1 = 1.E0 - EC * COS(E)
!
!    WRITE(6,999) JYR, JMNTH, JDAY, JHR, R1
!999 FORMAT('SUN-EARTH DISTANCE CALCULATION FINISHED IN SOLARD'/'YEAR=',I5,'  MONTH=',I3,         &
!    &      '  DAY=',I3,' HOUR=',I5,' R1=',F9.4)
!
!---------------- 
! RETURN TO RADTN
!----------------
    RETURN
!
    END SUBROUTINE SOLARD 

    MODULE ACMRDL
!>--------------------------------------------------------------------------------------------------
!> MODULE ACMRDL
!>
!> USE MODULES: F77KINDS
!>              PARMETA
!>
!> DRIVER     : CHKOUT
!>              GOSSIP
!>              INIT
!>              INITS
!>              RADTN
!>              RDTEMP
!>              READ_NHB
!>              READ_RESTRT
!>              READ_RESTRT2
!>              SURFCE
!>--------------------------------------------------------------------------------------------------
    USE F77KINDS
    USE PARMETA
!
    IMPLICIT NONE
!
    SAVE
!
    INTEGER(KIND=I4KIND)                                                                        ::&
    & NRDLW
!
    REAL   (KIND=R4KIND)                                                                        ::&
    & ARDLW   , TRDLW 
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2)                                   ::&
    & RLWIN   , RLWOUT  , RLWTOA  ,                                                               &
    & ALWIN   , ALWOUT  , ALWTOA
!
    REAL   (KIND=R4KIND), DIMENSION(IDIM1:IDIM2, JDIM1:JDIM2, LM)                               ::&
    & RLWTT
!
    END MODULE ACMRDL
